<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Handler_Coursework extends Controller_Handler_Map {

    public function before() {
        $this->setAccessLevel(self::ACCESS_USER);
        parent::before();
    }

    public function action_add() {
        $data['success'] = false;

        $this->post
            ->rule('type', 'matches', ['scientific', 'disciplinary'])
            ->rule('grade', 'not_empty')
            ->rule('grade', 'digit')
            ->rule('facultyID', 'not_empty')
            ->rule('facultyID', 'digit')
            ->rule('subjectID', 'not_empty')
            ->rule('subjectID', 'digit');

        if ($this->post->check()) {
            $discipline['id'] = Model_CourseWork::create([
                $this->post['FacultyID'],
                $this->post['Grade'],
                $this->user['TeacherID'],
                $this->post['SubjectID'],
                $this->post['type']
            ]);

            if ($discipline['id']) {
                // Attach all teachers of the department to coursework
                if ($this->post['type'] == 'scientific')
                    foreach (Model_Teachers::getTeachersByDepartment($this->user->DepID) as $teacher)
                        Model_Map::bindTeacher($this->user->TeacherID, $teacher['ID'], $discipline['id']);

                // Response to json client
                $data = [
                    'success' => true,
                    'id' => $discipline['id'],
                ];
            }
        }

        $this->response->body(json_encode($data));
    }
}